From 4f72c0d06f137eba1dd7f39d5b49eb0301e113ae Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 731/1001] Convert the subscriptions widget


---

diff --git a/hubs/widgets/subscriptions/__init__.py b/hubs/widgets/subscriptions/__init__.py
new file mode 100644
index 0000000..352945d
--- /dev/null
+++ b/hubs/widgets/subscriptions/__init__.py
@@ -0,0 +1,78 @@
+from __future__ import unicode_literals
+
+import flask
+import hubs.models
+
+from hubs import validators
+from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.chrome import panel
+
+from fedmsg.meta.base import BaseConglomerator as BC
+
+import fedmsg.config
+fm_config = fedmsg.config.load_config()
+
+
+class Subscriptions(Widget):
+
+    name = "subscriptions"
+    position = "right"
+    arguments = [
+        dict(
+            name="username",
+            label="Username",
+            default=None,
+            validator=validators.username,
+            help="A FAS username.",
+        )]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/subscriptions.html"
+    chrome = panel('Hubs', key='associations')
+
+    def get_context(self, instance, *args, **kwargs):
+        get_subs = GetSubs(instance)
+        return get_subs()
+
+
+# function hyperlinks the hubs in the subscription widget
+def manage_subscriptions(items):
+    return [
+        '<a href="{link}">{item}</a>'.format(
+            link=flask.url_for('hub', name=item),
+            item=item,
+        ) for index, item in enumerate(items[0:3])
+    ]
+
+
+class GetSubs(CachedFunction):
+
+    def execute(self):
+        username = self.instance.config["username"]
+        user = hubs.models.User.by_username(username)
+        ownerships = [u.name for u in user.ownerships]
+        memberships = [u.name for u in user.memberships]
+        subscriptions = [u.name for u in user.subscriptions]
+        subscriptions_list = manage_subscriptions(subscriptions)
+        memberships_list = manage_subscriptions(memberships)
+        return dict(
+            associations=memberships + ownerships,
+            ownerships=ownerships,
+            memberships=memberships,
+            subscriptions=subscriptions,
+            ownerships_text=BC.list_to_series(ownerships),
+            memberships_text=BC.list_to_series(memberships_list),
+            subscriptions_text=BC.list_to_series(subscriptions_list),
+        )
+
+    def should_invalidate(self, message):
+        if not message['topic'].endswith('hubs.associate'):
+            return False
+        username = self.instance.config['username']
+        users = fedmsg.meta.msg2usernames(message, **fm_config)
+        return username in users

